/* qprompt.c 
   version 2
   May, 1994

   by Alex Kent ... alex@nmt.edu

   Feel free to modify this code to your hearts content; trash it, thrash,
   rewrite it.

   Maybe some others will find it as useful and easy to use as I have.

   To compile:
   cc qprompt.c -o qprompt
       or
   gcc qprompt.c -c qprompt

   simple program=simple installing

*/
   



#include <stdio.h>
#include <termios.h>
#include <sys/fcntl.h>
#include <signal.h>
#include <sys/time.h>
#include <string.h>
#define MAXVARIATIONS 10

int fd;
struct termios org_tty;
int aflag;

void timed_out(void)
{
  tcsetattr(fd, TCSAFLUSH, &org_tty);
  printf("\n");
  exit(0);
}

int checkit(char c,int leng, char *list[])
{
  int i,j,start;
  if (aflag)
    start=3;
  else
    start=2;
  for (i=start;i<leng;i++)
    for (j=0;j<MAXVARIATIONS;j++) {
      if (list[i][j]=='\0')
	break;
      if (list[i][j]!='/') {
	if (list[i][j]==c)
	  return i-start+3;
      }
    }
  return -3;
}  

void main(int argc, char *argv[])
{
  int i,maxtime;
  char c;
  char option[4];
  int sig=-3;
  struct termios buf;

  if (argc<2) {
    printf("Usage: qprompt [-a] x [c/c/c ... ....]\n");
    printf("where x is time in seconds, c is input characters.\n");
    printf("the -a option allows any keypress to return a 2\n");
    exit(-3);
  }
  sscanf(argv[1],"%s",option);
  if (option[0]=='-') {
    if (argc<3) {
      printf("No time specified\n");
      exit(-3);
    }
    aflag=1;
    sscanf(argv[2],"%d",&maxtime);
  }
  else {
    aflag=0;
    sscanf(option,"%d",&maxtime);
  }
  if (maxtime<0 || maxtime>9999) {
    printf("Invalid time specification.\n");
    exit(-3);
  }
  if (maxtime>0)
    signal(SIGALRM,(void *)timed_out);
  fd=open("/dev/tty",O_RDWR);
  tcgetattr(fd, &org_tty);
  buf=org_tty;
  buf.c_lflag &= ~(ECHO|ICANON|IEXTEN);
  buf.c_oflag &= ~(OPOST);
  buf.c_cc[VMIN] = 1;
  buf.c_cc[VTIME] = 0;
  tcsetattr(fd, TCSAFLUSH, &buf);
  if (maxtime>0)
    alarm(maxtime);
  while ( (i=read(fd,&c,1))==1) {
    if (c=='\n') {
      if (aflag && argc==3)
	sig=2;
      else    
	sig=1;
      break;
    }
    sig=checkit(c,argc,argv);
    if (sig>0)
      break;
    if (aflag) { /* an any key is OK ... return a 2 */
      sig=2;
      break;
    }
  }
  tcsetattr(fd, TCSAFLUSH, &org_tty);
  printf("\n");
  exit(sig);
}









